SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Object subclass: #Book
	instanceVariableNames: 'isbn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Book methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:38'!
isbn

	^isbn! !

Object subclass: #Cart
	instanceVariableNames: 'booksInCart publisherCatalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:39'!
add: aBook

	^(self isFromThePublisher: aBook) ifTrue: [ booksInCart add: aBook ] ifFalse: [ Error signal ]! !

!Cart methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:53'!
initializeWithPublisherCatalog: aPublisherCatalog

	booksInCart := Bag new.
	publisherCatalog := aPublisherCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:39'!
isEmpty

	^booksInCart isEmpty! !

!Cart methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:48'!
isFromThePublisher: aBook

	^publisherCatalog hasBook: aBook! !

Object subclass: #PublisherCatalog
	instanceVariableNames: 'books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!PublisherCatalog methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 18:09'!
hasBook: aBook

	^books includes: aBook! !

!PublisherCatalog methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 18:01'!
initializeWithBooks: aCollectionOfBooks

	books := aCollectionOfBooks! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:53'!
test01CartShouldBeEmptyAfterCreation

	| cart |
	
	cart := Cart new initializeWithPublisherCatalog: PublisherCatalog new.
	self assert: cart isEmpty! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 17:59'!
test02CartShouldNotBeEmptyAfterAddingABook

	| cart book publisherCatalog |
	
	book := Book new.
	publisherCatalog := PublisherCatalog new initializeWithBooks: (Set with: book).
	cart := Cart new initializeWithPublisherCatalog: publisherCatalog.
	cart add: book.
	
	self deny: cart isEmpty! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/29/2013 18:10'!
test03CartShouldNotAllowToAddABookWhichIsNotFromThePublisher

	| cart book publisherCatalog |

	book := Book new.
	publisherCatalog := PublisherCatalog new initializeWithBooks: Set new.	
	cart := Cart new initializeWithPublisherCatalog: publisherCatalog.
	
	self should: [ cart add: book ] raise: Error! !
